var registration = {
    getCallbackUpdateResult: function(selInfinibox) {
        var callback = function (json) {
            var info = infinibox.getInfo(selInfinibox);
            var notRegistered = view.select(".not-registered", info);
            infinibox.getAjaxLoader(selInfinibox).hide();
            infinibox.getInfo(selInfinibox).unblock();
            if (json.return_value == true) {
                info.unblock();
                info.removeClass("unregistered");
                infinibox.getActionContainer(selInfinibox).show();
                notRegistered.hide();
            } else {
                infinibox.getRegistrationButton(selInfinibox).show();
                notRegistered.show();
                info.addClass("unregistered");
            }
        }
        return callback;
    },

    getRegisterHandler: function(selInfinibox) {
        var callback = function() {
            var serial = infinibox.getSerial(selInfinibox);
            spinnerFactory.block(infinibox.getInfo(selInfinibox), "small");
            auth.call_with_credentials(serial,
                function() {
                    var data = {serial: serial};
                    var ajaxOptions = {type: "POST", dataType: "json", data: data,
                                       cache: false, url: registration.ajaxSource};
                    var callback = registration.getUpdateCallback(selInfinibox);
                    spinnerFactory.block(infinibox.getInfo(selInfinibox), "small");
                    infinibox.getRegistrationButton(selInfinibox).hide();
                    view.select(".not-registered", selInfinibox).hide();
                    view.ajax(ajaxOptions, null, null, callback);
                },
                function() {
                    infinibox.getInfo(selInfinibox).unblock();
                }
            );
        }
        return callback;
    },

    showAjaxLoader: function(divInfinibox) {
        view.select(".not-registered", divInfinibox).hide();
        infinibox.getActionContainer(divInfinibox).hide();
        infinibox.getRegistrationButton(divInfinibox).hide();
        infinibox.getAjaxLoader(divInfinibox).show();
    },

    update: function(divInfinibox) {
        var selInfinibox = jQuery(divInfinibox);
        var serial = infinibox.getSerial(selInfinibox);
        var data = {serial: serial};
        var ajaxOptions = {type: "GET", dataType: "json", data: data,
                           cache: false, url: registration.ajaxSource};
        var callback = registration.getCallbackUpdateResult(selInfinibox);
        var button = jQuery(".register-button", selInfinibox);
        if (!button.length) return; // no register button - unsupported infinibox, don't query
        view.ajax(ajaxOptions, callback, null, null);
        registration.showAjaxLoader(divInfinibox);
    },

    getUpdateCallback: function(divInfinibox) {
        var callback = function() {
            registration.update(divInfinibox);
        }
        return callback;
    },

    setFixOnAll: function() {
        var foreach = function(index, divInfinibox) {
            var selInfinibox = jQuery(divInfinibox);
            var button = jQuery(".register-button", selInfinibox);
            var callback = registration.getRegisterHandler(selInfinibox);
            button.click(callback);
        }
        jQuery(".infinibox.root").each(foreach);
    },

    updateAll: function() {
        var foreach = function(index, divInfinibox) {
            registration.update(divInfinibox);
        }
        jQuery(".infinibox.root").each(foreach);
    },

    init: function() {
        registration.ajaxSource = sources.registration;
        spinnerFactory.create(jQuery(".register-ajax-loader"), "small");
        registration.setFixOnAll();
        registration.updateAll();
    }
}